﻿using System.Drawing.Drawing2D;

namespace KPGBase.Excercises
{
    internal class Excercise06 : BasicExcercise
    {
        public string lennaPath = "Lenna.png";

        // Matrices for image transformations
        private Matrix transformation;
        private Matrix rotation = new Matrix();
        private Matrix translation = new Matrix();

        // Mouse movement
        Point startPoint = new Point(0, 0);
        Point translationVector = new Point(0, 0);
        Point lastTranslationVector = new Point(0, 0);
        bool leftClicked;
        bool rightClicked;

        public Excercise06(Bitmap canvas) : base(canvas)
        {
            LoadImage(lennaPath);
            transformation = new Matrix(); // inits as identity matrix
        }

        /// <summary>
        /// Load image from path and set it as local canvas + create graphics
        /// </summary>
        /// <param name="path"> Path to image </param>
        public void LoadImage(string path)
        {
            Bitmap? lenna = LoadOriginalImg(path);
            if (lenna != null)
            {
                canvas = lenna;
                g = Graphics.FromImage(canvas);
            }
        }

        /// <summary>
        /// Load image from path
        /// </summary>
        /// <param name="path"> Path to image </param>
        /// <returns> Bitmap with loaded image </returns>
        private Bitmap? LoadOriginalImg(string path)
        {
            if (File.Exists(path))
                return (Bitmap)Image.FromFile(path);

            return null;
        }

        /// <summary>
        /// Converts image to black and white
        /// </summary>
        /// <returns> Edited image </returns>
        internal Bitmap BlackAndWhite()
        {
            // clone of the current bitmap - in it will be created the edited image created
            Bitmap bmp = (Bitmap)canvas.Clone();

            // Method that converts RGB image to greyscale image
            // Any grey color has all RGB components set to the same value
            // To obtain different grey tones through the image the values must correspond to the original pixel brightness
            // 
            // One pixel can be obtained by Bitmap.GetPixel(x,y) and then set as Bitmap.SetPixel(x, y, color)
            // Custom color can be created using Color.FromArgb(r, g, b)

            throw new NotImplementedException();

            canvas = bmp;
            Bitmap tfBmp = DrawTransformedBitmap();
            return tfBmp;
        }

        /// <summary>
        /// Applies embossing effect on the image
        /// </summary>
        /// <returns> Edited image </returns>
        internal Bitmap Emboss()
        {
            // clone of the current bitmap - in it will be created the edited image created
            Bitmap bmp = (Bitmap)canvas.Clone();

            // Method that applies embossing effect onto the image
            // Two pixels p1 = (i, j) and diagonal neighbor p2 = (i+1, j+1)
            // Get the difference of the values of every color channel separately p1 - p2
            // Add half of the allowed value interval to this difference
            // Set these values as new color

            throw new NotImplementedException();

            canvas = bmp;
            Bitmap tfBmp = DrawTransformedBitmap();
            return tfBmp;
        }

        /// <summary>
        /// Detects edges in the image
        /// </summary>
        /// <returns> Edited image </returns>
        internal Bitmap EdgeDetection()
        {
            // clone of the current bitmap - in it will be created the edited image created
            Bitmap bmp = (Bitmap)canvas.Clone();

            // Method that edge detection effect onto the image
            // For this we need four neighboring pixels
            // 1 2
            // 3 4
            // Compute the difference of pixel colours at the diagonals (eg. pixel 1 and 4, and pixel 2 and 3)
            // Add the differences and set them as the new color of pixel 1

            throw new NotImplementedException();

            canvas = bmp;
            Bitmap tfBmp = DrawTransformedBitmap();
            return tfBmp;
        }

        /// <summary>
        /// Custom effect
        /// </summary>
        internal Bitmap OwnEffect()
        {
            Bitmap bmp = (Bitmap)canvas.Clone();

            // Space to create your own effect

            throw new NotImplementedException();

            canvas = bmp;
            Bitmap tfBmp = DrawTransformedBitmap();
            return tfBmp;
        }

        /// <summary>
        /// Mouse clicked
        /// </summary>
        internal void MouseClicked(Point location, MouseButtons button)
        {
            startPoint = location;

            // left mouse button
            if (button == MouseButtons.Left)
                leftClicked = true;
            // right mouse button
            else if (button == MouseButtons.Right)
                rightClicked = true;
        }

        /// <summary>
        /// Mose un-clicked
        /// </summary>
        internal void MouseUp()
        {
            leftClicked = false;
            rightClicked = false;
        }

        /// <summary>
        /// Mouse moved
        /// - if left clicked -> translate
        /// - if right clicked -> rotate
        /// </summary>
        /// <returns> Transformed image </returns>
        internal Bitmap MouseMove(Point newLoc)
        {
            // if left button is clicked -> translating
            // Translating image on the canvas

            // translationVector - vector of difference of mouse position from previous position startPoint
            // translation - set translation of this matrix  translation.Translate(...)
            //             - matrix needs to be reset first!! translation.Reset()
            // lastTranslationVector - save the last tranlation of an image for future use
            // startPoint - save the location for future use

            // if right button is clicked -> rotating
            // Rotating image

            // rotation - matrix with image rotation
            // rotation can be for example the difference between x coordinates of startPoint and current position
            // apply rotation as rotation.Rotate(degrees)

            throw new NotImplementedException();

            Matrix transformation = new Matrix();

            // COMBINE ROTATION AND TRANSLATION into matrix transformation - multiplying matrices:
            // - matrix translation 
            // - matrix with translation to center of image
            // - rotation matrix
            // - move "from" the center of image            

            // draw the image
            this.transformation = transformation;
            Bitmap translated = DrawTransformedBitmap();
            return translated;
        }

        /// <summary>
        /// Draw bitmap transformed by transformation matrix
        /// </summary>
        /// <returns> Canvas with transformed image </returns>
        private Bitmap DrawTransformedBitmap()
        {
            Bitmap currImg = (Bitmap)canvas.Clone();

            //graphics access
            Graphics g = Graphics.FromImage(currImg);

            //clear canvas, apply transformations and draw image
            g.Clear(Color.White);
            g.Transform.Reset();
            g.Transform = transformation;

            g.DrawImage(canvas, 0, 0);
            return currImg;
        }
    }
}
